---
import { Edit2 as EditIcon } from 'lucide-astro';
import { env } from '~/lib/env';
import { getPageForUrl, getPages } from '~/lib/pages';
import { joinPaths } from '~/lib/path';

const CMS_PATH = 'staticcms/';
// const CMS_PATH = "decapcms/";

const currentPath = Astro.url.pathname;
const basePath = env.BASE_URL;
const strippedPath = currentPath.replace(new RegExp(`^${basePath}`), '');

const pages = getPages(await Astro.glob('/src/pages/**/*.{md,mdx,astro}'));
// Will be undefined if we are on a collection page
const page = getPageForUrl(pages, currentPath);
// TODO: Find better way to identify collection pages
const { slug } = Astro.params;

let editUrl;

if (page && !page.filename.endsWith('.md')) {
  editUrl = undefined;
} else if (
  //   page &&
  //   page.frontmatter?.rendersCollection &&
  //   typeof page.frontmatter?.rendersCollection === 'string'
  !!slug
) {
  const collection = 'posts'; //page.frontmatter?.rendersCollection;
  editUrl =
    joinPaths(basePath, CMS_PATH) + '#' + joinPaths('/collections', collection, 'entries', slug);
} else if (!!page) {
  editUrl =
    joinPaths(basePath, CMS_PATH) +
    '#' +
    joinPaths('/collections/pages/entries', strippedPath, 'index');
}
---

<>
  {
    editUrl && (
      <div class="flex justify-end mt-4">
        <a
          href={editUrl}
          target="_blank"
          class="bg-secondary flex items-center gap-1 py-2 px-4 rounded-lg font-medium"
        >
          <EditIcon size="16" class="inline-block" /> Edit this page
        </a>
      </div>
    )
  }
</>
